#include<bits/stdc++.h>
using namespace std;
long long n, k, niz[100050];
long long Delioci(long long broj)
{
    vector<long long> vektor;
    long long res;
    long long koren = sqrt(broj);

    for(int i=1; i<=broj; i++)
    {
        if(broj%i == 0)
            vektor.push_back(i);
    }

    /*cout << broj << "\n\n";
    for(int i=0; i<vektor.size(); i++)
        cout << vektor[i] << ", ";
    cout <<"\n";*/
    res = 1; /// PRVI DELILAC
    for(int i=1; i<vektor.size(); i++)
        res = (res ^ vektor[i]);


    return res;
}

int main()
{
    cin >> n >> k;
    for(int i=1; i<=k; i++)
        cin >> niz[i];

    for(int i=1; i<=k; i++)
        cout << Delioci(niz[i]) << " ";
    cout << "\n";

    return 0;
}